from sqlalchemy import (Column, Integer, String, DateTime, func, ForeignKey)
from app import db
from sqlalchemy.ext.declarative import declarative_base
from sqlalchemy.orm import relationship

Base: declarative_base = db.Model

class Zone(Base):
    __tablename__ = "zone"
    zone_id = Column(Integer, primary_key=True)
    site_id = Column(Integer, ForeignKey('sites.site_id'))
    site = relationship("Site", back_populates="zone")
    zone_name = Column(String, nullable=True)
    x_min = Column(String, nullable=False)
    y_min = Column(String, nullable=False)
    x_max = Column(String, nullable=False)
    y_max = Column(String, nullable=False)
    created_at = Column(DateTime(timezone=True), default=func.now())
    updated_at = Column(DateTime(timezone=True), default=func.now())

    rooms = relationship("Room", cascade="all, delete-orphan", backref="zone_ref")
    def __init__(self, zone_name, x_min, y_min, x_max, y_max, site_id):
        self.zone_name = zone_name
        self.x_min = x_min
        self.y_min = y_min
        self.x_max = x_max
        self.y_max = y_max
        self.site_id = site_id